docker-build:
  # Use the official docker image.
  image: redserenity/docker:cli
  stage: build
  services:
    - docker:dind
  variables:
    DOCKER_IMAGE_NAME: $DOCKER_HUB_REPOSITORY/coredns:multifilter
  before_script:
    - echo "$DOCKER_HUB_TOKEN" | docker login docker.io --username $DOCKER_HUB_USER --password-stdin
  script:
    - |
      VERSION=$(echo "$CI_COMMIT_TAG" | sed 's/^docker-build.v//') # Extract vX.X.X from the tag
      DOCKER_IMAGE_NAME_VERSION="$DOCKER_IMAGE_NAME-$VERSION"

      echo "Docker Image: $DOCKER_IMAGE_NAME"
      echo "Docker Image Version: $VERSION"
      echo "Docker Image Full Tag: $DOCKER_IMAGE_NAME_VERSION"

      cd coredns
      docker build --pull -t "$DOCKER_IMAGE_NAME" -t "$DOCKER_IMAGE_NAME_VERSION" .
      docker push "$DOCKER_IMAGE_NAME"
      docker push "$DOCKER_IMAGE_NAME_VERSION"
  rules:
    - if: $CI_COMMIT_TAG =~ /^docker-build\.v[0-9]+\.[0-9]+\.[0-9]+$/
      exists:
        - coredns/Dockerfile